'use strict';

exports.__esModule = true;

var _isNumber2 = require('lodash/isNumber');

var _isNumber3 = _interopRequireDefault(_isNumber2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _isNull2 = require('lodash/isNull');

var _isNull3 = _interopRequireDefault(_isNull2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _domLib = require('dom-lib');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('rsuite-utils/lib/utils');

var _utils2 = require('../utils');

var _stringToObject2 = require('../utils/stringToObject');

var _stringToObject3 = _interopRequireDefault(_stringToObject2);

var _DropdownMenuItem = require('../_picker/DropdownMenuItem');

var _DropdownMenuItem2 = _interopRequireDefault(_DropdownMenuItem);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var DropdownMenu = function (_React$Component) {
  _inherits(DropdownMenu, _React$Component);

  function DropdownMenu() {
    var _temp, _this, _ret;

    _classCallCheck(this, DropdownMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.menus = [], _this.handleSelect = function (layer, index, node, event) {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          childrenKey = _this$props.childrenKey;

      var children = node[childrenKey];
      var isLeafNode = (0, _isUndefined3.default)(children) || (0, _isNull3.default)(children);
      var items = (children || []).map(function (item) {
        return _extends({}, _this.stringToObject(item), {
          parent: node
        });
      });

      var _this$getCascadeItems = _this.getCascadeItems(items, layer + 1, node, isLeafNode),
          cascadeItems = _this$getCascadeItems.cascadeItems,
          cascadePathItems = _this$getCascadeItems.cascadePathItems;

      onSelect && onSelect(node, cascadeItems, cascadePathItems, isLeafNode, event);
    }, _this.addPrefix = function (name) {
      return (0, _utils2.prefix)(_this.props.classPrefix)(name);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  DropdownMenu.prototype.componentDidMount = function componentDidMount() {
    this.scrollToActiveItemTop();
  };

  DropdownMenu.prototype.getCascadeItems = function getCascadeItems(items, layer, node, isLeafNode) {
    var _props = this.props,
        _props$cascadeItems = _props.cascadeItems,
        cascadeItems = _props$cascadeItems === undefined ? [] : _props$cascadeItems,
        cascadePathItems = _props.cascadePathItems;

    var nextItems = [];
    var nextPathItems = [];

    for (var i = 0; i < cascadeItems.length && i < layer; i += 1) {
      nextItems.push(cascadeItems[i]);
      if (i < layer - 1 && cascadePathItems) {
        nextPathItems.push(cascadePathItems[i]);
      }
    }

    nextPathItems.push(node);
    if (!isLeafNode) {
      nextItems.push(items);
    }

    return {
      cascadeItems: nextItems,
      cascadePathItems: nextPathItems
    };
  };

  DropdownMenu.prototype.stringToObject = function stringToObject(value) {
    var _props2 = this.props,
        labelKey = _props2.labelKey,
        valueKey = _props2.valueKey;

    return (0, _stringToObject3.default)(value, labelKey, valueKey);
  };

  DropdownMenu.prototype.scrollToActiveItemTop = function scrollToActiveItemTop() {
    var _this2 = this;

    if (!this.menus) {
      return;
    }
    this.menus.forEach(function (menu) {
      if (!menu) {
        return;
      }

      var activeItem = menu.querySelector('.' + _this2.addPrefix('item-focus'));

      if (!activeItem) {
        activeItem = menu.querySelector('.' + _this2.addPrefix('item-active'));
      }

      if (activeItem) {
        var position = (0, _domLib.getPosition)(activeItem, menu);
        (0, _domLib.scrollTop)(menu, position.top);
      }
    });
  };

  DropdownMenu.prototype.renderCascadeNode = function renderCascadeNode(node, index, layer, focus) {
    var _props3 = this.props,
        activeItemValue = _props3.activeItemValue,
        valueKey = _props3.valueKey,
        labelKey = _props3.labelKey,
        childrenKey = _props3.childrenKey,
        disabledItemValues = _props3.disabledItemValues,
        renderMenuItem = _props3.renderMenuItem;


    var children = node[childrenKey];
    var value = node[valueKey];
    var label = node[labelKey];

    var disabled = disabledItemValues.some(function (disabledValue) {
      return (0, _utils.shallowEqual)(disabledValue, value);
    });

    // Use `value` in keys when If `value` is string or number
    var onlyKey = (0, _isString3.default)(value) || (0, _isNumber3.default)(value) ? value : index;

    return React.createElement(
      _DropdownMenuItem2.default,
      {
        classPrefix: this.addPrefix('item'),
        key: layer + '-' + onlyKey,
        disabled: disabled,
        active: !(0, _isUndefined3.default)(activeItemValue) && (0, _utils.shallowEqual)(activeItemValue, value),
        focus: focus,
        value: node,
        className: children ? this.addPrefix('has-children') : undefined,
        onSelect: this.handleSelect.bind(this, layer, index)
      },
      renderMenuItem ? renderMenuItem(label, node) : label,
      children ? React.createElement('span', { className: this.addPrefix('caret') }) : null
    );
  };

  DropdownMenu.prototype.renderCascade = function renderCascade() {
    var _this3 = this;

    var _props4 = this.props,
        menuWidth = _props4.menuWidth,
        menuHeight = _props4.menuHeight,
        valueKey = _props4.valueKey,
        renderMenu = _props4.renderMenu,
        _props4$cascadeItems = _props4.cascadeItems,
        cascadeItems = _props4$cascadeItems === undefined ? [] : _props4$cascadeItems,
        cascadePathItems = _props4.cascadePathItems;


    var styles = {
      width: cascadeItems.length * menuWidth
    };
    var cascadeNodes = cascadeItems.map(function (children, layer) {
      var onlyKey = layer + '_' + children.length;
      var menu = React.createElement(
        'ul',
        null,
        children.map(function (item, index) {
          return _this3.renderCascadeNode(item, index, layer, cascadePathItems[layer] && (0, _utils.shallowEqual)(cascadePathItems[layer][valueKey], item[valueKey]));
        })
      );

      var parentNode = cascadePathItems[layer - 1];
      var node = React.createElement(
        'div',
        {
          key: onlyKey,
          className: _this3.addPrefix('column'),
          ref: function ref(_ref) {
            _this3.menus[layer] = _ref;
          },
          style: {
            height: menuHeight,
            width: menuWidth
          }
        },
        renderMenu ? renderMenu(children, menu, parentNode) : menu
      );
      return node;
    });
    return React.createElement(
      'div',
      { style: styles },
      cascadeNodes
    );
  };

  DropdownMenu.prototype.render = function render() {
    var _props5 = this.props,
        className = _props5.className,
        rest = _objectWithoutProperties(_props5, ['className']);

    var classes = (0, _classnames2.default)(this.addPrefix('items'), className);
    var unhandled = (0, _utils2.getUnhandledProps)(DropdownMenu, rest);

    return React.createElement(
      'div',
      _extends({}, unhandled, { className: classes }),
      this.renderCascade()
    );
  };

  return DropdownMenu;
}(React.Component);

DropdownMenu.defaultProps = {
  data: [],
  disabledItemValues: [],
  cascadeItems: [],
  cascadePathItems: [],
  menuWidth: 120,
  menuHeight: 200,
  childrenKey: 'children',
  valueKey: 'value',
  labelKey: 'label'
};
DropdownMenu.handledProps = ['activeItemValue', 'cascadeItems', 'cascadePathItems', 'childrenKey', 'className', 'classPrefix', 'data', 'disabledItemValues', 'labelKey', 'menuHeight', 'menuWidth', 'onSelect', 'renderMenu', 'renderMenuItem', 'valueKey'];
DropdownMenu.propTypes = {
  classPrefix: _propTypes2.default.string.isRequired,
  data: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  disabledItemValues: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  activeItemValue: _propTypes2.default.any,
  childrenKey: _propTypes2.default.string.isRequired,
  valueKey: _propTypes2.default.string.isRequired,
  labelKey: _propTypes2.default.string.isRequired,
  menuWidth: _propTypes2.default.number.isRequired,
  menuHeight: _propTypes2.default.number.isRequired,
  className: _propTypes2.default.string,
  renderMenuItem: _propTypes2.default.func,
  renderMenu: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  cascadeItems: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  cascadePathItems: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired
};
exports.default = DropdownMenu;