'use strict';

exports.__esModule = true;

var _isNil2 = require('lodash/isNil');

var _isNil3 = _interopRequireDefault(_isNil2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _InputGroup = require('./InputGroup');

var _InputGroup2 = _interopRequireDefault(_InputGroup);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('./Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _utils = require('./utils');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var isFloat = function isFloat(value) {
  return (/(^-?|^\+?|^\d?)\d*\.\d+$/.test(value + '')
  );
};

function getDecimalLength(value) {
  if (isFloat(value)) {
    return value.toString().split('.')[1].length;
  }
  return 0;
}

function decimals() {
  for (var _len = arguments.length, values = Array(_len), _key = 0; _key < _len; _key++) {
    values[_key] = arguments[_key];
  }

  var lengths = values.map(getDecimalLength);
  return Math.max.apply(Math, lengths);
}

function getButtonStatus(value, min, max) {
  var status = {
    disabledUpButton: false,
    disabledDownButton: false
  };
  if (typeof value !== 'undefined' && value !== null) {
    status.disabledUpButton = +value >= max;
    status.disabledDownButton = +value <= min;
  }
  return status;
}

var InputNumber = function (_React$Component) {
  _inherits(InputNumber, _React$Component);

  function InputNumber(props) {
    _classCallCheck(this, InputNumber);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    var value = props.value,
        defaultValue = props.defaultValue,
        max = props.max,
        min = props.min;

    var _getButtonStatus = getButtonStatus((0, _isUndefined3.default)(value) ? defaultValue : value, min, max),
        disabledUpButton = _getButtonStatus.disabledUpButton,
        disabledDownButton = _getButtonStatus.disabledDownButton;

    _this.state = {
      value: defaultValue,
      disabledUpButton: disabledUpButton,
      disabledDownButton: disabledDownButton
    };
    return _this;
  }

  InputNumber.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps) {
    if (typeof nextProps.value !== 'undefined') {
      var _value = nextProps.value,
          _min = nextProps.min,
          _max = nextProps.max;

      return getButtonStatus(_value, _min, _max);
    }
    return null;
  };

  InputNumber.prototype.getValue = function getValue() {
    var value = this.props.value;

    return (0, _isUndefined3.default)(value) ? this.state.value : value;
  };

  InputNumber.prototype.getSafeValue = function getSafeValue(value) {
    var _props = this.props,
        max = _props.max,
        min = _props.min;

    if (!Number.isNaN(value)) {
      if (+value > max) {
        value = max;
      }
      if (+value < min) {
        value = min;
      }
    } else {
      value = '';
    }
    return value;
  };

  InputNumber.prototype.handleValue = function handleValue(currentValue, event, input) {
    var value = this.state.value;
    var _props2 = this.props,
        onChange = _props2.onChange,
        min = _props2.min,
        max = _props2.max;


    if (currentValue !== value) {
      this.setState(_extends({}, getButtonStatus(currentValue, min, max), {
        value: currentValue
      }));

      if (!input && onChange) {
        onChange(currentValue, event);
      }
    }
  };

  InputNumber.prototype.render = function render() {
    var _props3 = this.props,
        disabled = _props3.disabled,
        size = _props3.size,
        prefixElement = _props3.prefix,
        postfix = _props3.postfix,
        className = _props3.className,
        classPrefix = _props3.classPrefix,
        step = _props3.step,
        buttonAppearance = _props3.buttonAppearance,
        props = _objectWithoutProperties(_props3, ['disabled', 'size', 'prefix', 'postfix', 'className', 'classPrefix', 'step', 'buttonAppearance']);

    var _state = this.state,
        disabledUpButton = _state.disabledUpButton,
        disabledDownButton = _state.disabledDownButton;

    var value = this.getValue();
    var addPrefix = (0, _utils.prefix)(classPrefix);
    var classes = (0, _classnames2.default)(classPrefix, className);
    var unhandled = (0, _utils.getUnhandledProps)(InputNumber, props);

    var _partitionHTMLProps = (0, _utils.partitionHTMLProps)(unhandled),
        htmlInputProps = _partitionHTMLProps[0],
        rest = _partitionHTMLProps[1];

    return React.createElement(
      _InputGroup2.default,
      _extends({}, rest, { className: classes, disabled: disabled, size: size }),
      prefixElement && React.createElement(
        _InputGroup2.default.Addon,
        null,
        prefixElement
      ),
      React.createElement(_Input2.default, _extends({}, htmlInputProps, {
        type: 'text',
        step: step,
        onChange: this.handleOnChange,
        onBlur: this.handleBlur,
        value: (0, _isNil3.default)(value) ? '' : value,
        onWheel: this.handleWheel,
        disabled: disabled
      })),
      React.createElement(
        'span',
        { className: addPrefix('btn-group-vertical') },
        React.createElement(
          _Button2.default,
          {
            appearance: buttonAppearance,
            className: addPrefix('touchspin-up'),
            onClick: this.handlePlus,
            disabled: disabledUpButton || disabled
          },
          React.createElement(_Icon2.default, { icon: 'arrow-up-line' })
        ),
        React.createElement(
          _Button2.default,
          {
            appearance: buttonAppearance,
            className: addPrefix('touchspin-down'),
            onClick: this.handleMinus,
            disabled: disabledDownButton || disabled
          },
          React.createElement(_Icon2.default, { icon: 'arrow-down-line' })
        )
      ),
      postfix && React.createElement(
        _InputGroup2.default.Addon,
        null,
        postfix
      )
    );
  };

  return InputNumber;
}(React.Component);

InputNumber.defaultProps = {
  min: -Infinity,
  max: Infinity,
  step: 1,
  buttonAppearance: 'subtle'
};
InputNumber.handledProps = ['buttonAppearance', 'className', 'classPrefix', 'defaultValue', 'disabled', 'max', 'min', 'onChange', 'onWheel', 'postfix', 'prefix', 'size', 'step', 'value'];
InputNumber.propTypes = {
  className: _propTypes2.default.string,
  classPrefix: _propTypes2.default.string.isRequired,
  min: _propTypes2.default.number.isRequired,
  max: _propTypes2.default.number.isRequired,
  step: _propTypes2.default.number.isRequired,
  value: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  prefix: _propTypes2.default.node,
  postfix: _propTypes2.default.node,
  disabled: _propTypes2.default.bool,
  size: _propTypes2.default.oneOf(['lg', 'md', 'sm', 'xs']),
  onWheel: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  buttonAppearance: _propTypes2.default.oneOf(['default', 'primary', 'link', 'subtle', 'ghost'])
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.handleOnChange = function (value, event) {
    if (!/^-?(?:\d+)?(\.)?(\d+)*$/.test(value) && value !== '') {
      return;
    }
    var isUnControl = (0, _isUndefined3.default)(_this2.props.value);

    _this2.handleValue(value, event, isUnControl);
  };

  this.handleBlur = function (event) {
    var _props4 = _this2.props,
        max = _props4.max,
        min = _props4.min;

    var targetValue = Number.parseFloat(event.target.value);
    _this2.handleValue(_this2.getSafeValue(targetValue), event);
  };

  this.handleWheel = function (event) {
    var _props5 = _this2.props,
        onWheel = _props5.onWheel,
        disabled = _props5.disabled;

    if (!disabled && event.target === document.activeElement) {
      event.preventDefault();
      var delta = (0, _get3.default)(event, 'wheelDelta') || -event.deltaY || -event.detail;

      if (delta > 0) {
        _this2.handleMinus(event);
      }
      if (delta < 0) {
        _this2.handlePlus(event);
      }
    }

    onWheel && onWheel(event);
  };

  this.handlePlus = function (event) {
    var _props6 = _this2.props,
        step = _props6.step,
        max = _props6.max;

    var value = +(_this2.getValue() || 0);
    var bit = decimals(value, step);
    var nextValue = (value + step).toFixed(bit);

    _this2.handleValue(_this2.getSafeValue(nextValue), event);
  };

  this.handleMinus = function (event) {
    var _props7 = _this2.props,
        step = _props7.step,
        min = _props7.min;

    var value = +(_this2.getValue() || 0);
    var bit = decimals(value, step);
    var nextValue = (value - step).toFixed(bit);

    _this2.handleValue(_this2.getSafeValue(nextValue), event);
  };
};

(0, _reactLifecyclesCompat.polyfill)(InputNumber);

exports.default = (0, _utils.defaultProps)({
  classPrefix: 'input-number'
})(InputNumber);