'use strict';

exports.__esModule = true;

var _isNumber2 = require('lodash/isNumber');

var _isNumber3 = _interopRequireDefault(_isNumber2);

var _isString2 = require('lodash/isString');

var _isString3 = _interopRequireDefault(_isString2);

var _kebabCase2 = require('lodash/kebabCase');

var _kebabCase3 = _interopRequireDefault(_kebabCase2);

var _trim2 = require('lodash/trim');

var _trim3 = _interopRequireDefault(_trim2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _isUndefined2 = require('lodash/isUndefined');

var _isUndefined3 = _interopRequireDefault(_isUndefined2);

var _isArray2 = require('lodash/isArray');

var _isArray3 = _interopRequireDefault(_isArray2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactDom = require('react-dom');

var _domLib = require('dom-lib');

var _rsuiteIntl = require('rsuite-intl');

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _OverlayTrigger = require('rsuite-utils/lib/Overlay/OverlayTrigger');

var _OverlayTrigger2 = _interopRequireDefault(_OverlayTrigger);

var _utils = require('rsuite-utils/lib/utils');

var _Picker = require('rsuite-utils/lib/Picker');

var _TreeNode = require('./TreeNode');

var _TreeNode2 = _interopRequireDefault(_TreeNode);

var _utils2 = require('../utils');

var _PickerToggle = require('../_picker/PickerToggle');

var _PickerToggle2 = _interopRequireDefault(_PickerToggle);

var _getToggleWrapperClassName = require('../_picker/getToggleWrapperClassName');

var _getToggleWrapperClassName2 = _interopRequireDefault(_getToggleWrapperClassName);

var _onMenuKeyDown = require('../_picker/onMenuKeyDown');

var _onMenuKeyDown2 = _interopRequireDefault(_onMenuKeyDown);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Tree = function (_React$Component) {
  _inherits(Tree, _React$Component);

  function Tree(props) {
    _classCallCheck(this, Tree);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _initialiseProps.call(_this);

    _this.isControlled = 'value' in props;
    var data = props.data,
        valueKey = props.valueKey;

    var nextData = (0, _utils2.clone)(data);
    _this.flattenNodes(nextData);
    _this.state = {
      data: props.data,
      value: props.value,
      selectedValue: _this.getValue(props),
      expandAll: _this.getExpandAll(props),
      filterData: _this.getFilterData(nextData, props.searchKeyword, props),
      activeNode: _this.getActiveNode(_this.getValue(props), valueKey),
      searchWord: props.searchKeyword || '',
      searchKeyword: props.searchKeyword || ''
    };
    return _this;
  }

  Tree.prototype.componentDidMount = function componentDidMount() {
    var activeNode = this.state.activeNode;

    this.focusNode(activeNode);
  };

  Tree.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    var value = nextProps.value,
        data = nextProps.data,
        expandAll = nextProps.expandAll,
        valueKey = nextProps.valueKey,
        searchKeyword = nextProps.searchKeyword;

    var nextState = {};
    if ((0, _isArray3.default)(data) && (0, _isArray3.default)(prevState.data) && !(0, _utils.shallowEqualArray)(prevState.data, data)) {
      nextState.data = data;
    }

    if (!(0, _utils.shallowEqual)(value, prevState.value)) {
      nextState.value = value;
      nextState.selectedValue = value;
    }

    if (prevState.searchKeyword !== searchKeyword) {
      nextState.searchWord = searchKeyword;
    }

    if (expandAll !== prevState.expandAll) {
      nextState.expandAll = expandAll;
    }

    return Object.keys(nextState).length ? nextState : null;
  };

  Tree.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var _state = this.state,
        filterData = _state.filterData,
        searchWord = _state.searchWord,
        selectedValue = _state.selectedValue;
    var _props = this.props,
        value = _props.value,
        data = _props.data,
        expandAll = _props.expandAll,
        valueKey = _props.valueKey,
        searchKeyword = _props.searchKeyword;

    if (!(0, _utils.shallowEqualArray)(prevState.data, data)) {
      var nextData = (0, _utils2.clone)(data);
      this.flattenNodes(nextData);
      var _filterData = this.getFilterData(nextData, searchWord);
      var _activeNode = this.getActiveNode(this.getValue());
      this.focusNode(_activeNode);
      this.setState({
        data: nextData,
        filterData: _filterData,
        activeNode: _activeNode
      });
    }

    if (!(0, _utils.shallowEqual)(prevState.value, value)) {
      var _activeNode2 = null;
      if (this.node === null) {
        _activeNode2 = this.getActiveNode(value);
      }

      if (value !== null && this.node !== null) {
        _activeNode2 = (0, _utils.shallowEqual)(this.node[valueKey], value) ? this.node : this.getActiveNode(value);
      }
      var nextState = {
        value: value,
        activeNode: _activeNode2
      };

      if (value === null) {
        nextState.activeNode = null;
        this.node = null;
      }

      if (_activeNode2 !== null) {
        this.focusNode(_activeNode2);
      }
      this.setState(nextState);
    }

    if (prevProps.searchKeyword !== this.props.searchKeyword) {
      this.setState({
        filterData: this.getFilterData(filterData, searchKeyword),
        searchWord: searchKeyword
      });
    }
  };

  Tree.prototype.getExpandAll = function getExpandAll() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;

    return props.expandAll !== undefined ? props.expandAll : props.defaultExpandAll;
  };

  Tree.prototype.getValue = function getValue() {
    var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
    var value = props.value,
        defaultValue = props.defaultValue;

    return !(0, _isUndefined3.default)(value) ? value : defaultValue;
  };

  Tree.prototype.getActiveNode = function getActiveNode(value) {
    var _this2 = this;

    var valueKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props.valueKey;

    var activeNode = null;
    if (!(0, _isUndefined3.default)(value)) {
      Object.keys(this.nodes).forEach(function (refKey) {
        if ((0, _utils.shallowEqual)(_this2.nodes[refKey][valueKey], value)) {
          activeNode = _this2.nodes[refKey];
        }
      });
    }

    return activeNode;
  };

  Tree.prototype.getExpandState = function getExpandState(node) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;

    var expandAll = this.getExpandAll(props);
    var childrenKey = props.childrenKey;

    if (node[childrenKey] && node[childrenKey].length) {
      if ('expand' in node) {
        return !!node.expand;
      } else if (expandAll) {
        return true;
      }
      return false;
    }
    return false;
  };

  Tree.prototype.getActiveElementOption = function getActiveElementOption(options, value) {
    for (var i = 0; i < options.length; i += 1) {
      if (options[i].value === value) {
        return options[i];
      } else if (options[i].children && options[i].children.length) {
        var active = this.getActiveElementOption(options[i].children, value);
        if (!(0, _isEmpty3.default)(active)) {
          return active;
        }
      }
    }
    return {};
  };

  Tree.prototype.getItemsAndActiveIndex = function getItemsAndActiveIndex() {
    var items = this.getFocusableMenuItems();

    var activeIndex = -1;
    items.forEach(function (item, index) {
      if (document.activeElement !== null) {
        if (item.refKey === document.activeElement.getAttribute('data-key')) {
          activeIndex = index;
        }
      }
    });
    return { items: items, activeIndex: activeIndex };
  };

  Tree.prototype.getActiveItem = function getActiveItem() {
    var nodeData = {};
    if (document.activeElement !== null) {
      var activeItem = document.activeElement;
      var _activeItem$dataset = activeItem.dataset,
          key = _activeItem$dataset.key,
          _layer = _activeItem$dataset.layer;

      var _activeNode3 = this.nodes[key];
      if (_activeNode3) {
        nodeData = _activeNode3;
      }
      return {
        nodeData: nodeData,
        layer: _layer
      };
    }
    return {};
  };

  Tree.prototype.getFilterData = function getFilterData(data, word) {
    var _this3 = this;

    var props = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.props;
    var labelKey = props.labelKey;


    var setVisible = function setVisible() {
      var nodes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      return nodes.forEach(function (item) {
        item.visible = _this3.shouldDisplay(item[labelKey], word);
        if ((0, _isArray3.default)(item.children)) {
          setVisible(item.children);
          item.children.forEach(function (child) {
            if (child.visible) {
              item.visible = child.visible;
            }
          });
        }
      });
    };

    if (!(0, _isUndefined3.default)(word) || !word !== '') {
      setVisible(data);
    }
    return data;
  };

  // for test


  Tree.prototype.focusNode = function focusNode(activeNode) {
    var inline = this.props.inline;

    if (activeNode && inline) {
      var node = this.getElementByDataKey(activeNode.refKey);
      if (node !== null) {
        node.focus();
      }
    }
  };
  /**
   * 将数组变为对象
   * @param {*} nodes tree data
   * @param {*} ref 当前层级
   */


  Tree.prototype.flattenNodes = function flattenNodes(nodes) {
    var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;

    var _this4 = this;

    var ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '0';
    var parentNode = arguments[3];
    var labelKey = props.labelKey,
        valueKey = props.valueKey,
        childrenKey = props.childrenKey;


    if (!Array.isArray(nodes) || nodes.length === 0) {
      return [];
    }
    nodes.map(function (node, index) {
      var _this4$nodes$refKey;

      var refKey = ref + '-' + index;
      node.refKey = refKey;
      node.expand = _this4.getExpandState(node, props);
      _this4.nodes[refKey] = (_this4$nodes$refKey = {}, _this4$nodes$refKey[labelKey] = node[labelKey], _this4$nodes$refKey[valueKey] = node[valueKey], _this4$nodes$refKey.expand = node.expand, _this4$nodes$refKey.refKey = refKey, _this4$nodes$refKey);
      if (parentNode) {
        _this4.nodes[refKey].parentNode = parentNode;
      }
      _this4.flattenNodes(node[childrenKey], props, refKey, _this4.nodes[refKey]);
    });
  };

  // 展开，收起节点


  Tree.prototype.renderDropdownMenu = function renderDropdownMenu() {
    var _props2 = this.props,
        searchable = _props2.searchable,
        placement = _props2.placement,
        renderExtraFooter = _props2.renderExtraFooter,
        locale = _props2.locale,
        renderMenu = _props2.renderMenu,
        menuStyle = _props2.menuStyle,
        menuClassName = _props2.menuClassName;


    var classes = (0, _classnames2.default)(menuClassName, this.addPrefix('tree-menu'), this.addPrefix('placement-' + (0, _kebabCase3.default)(placement)));

    return React.createElement(
      _Picker.MenuWrapper,
      { className: classes, style: menuStyle, ref: this.bindMenuRef },
      searchable ? React.createElement(_Picker.SearchBar, {
        placeholder: locale.searchPlaceholder,
        key: 'searchBar',
        onChange: this.handleSearch,
        value: this.state.searchWord
      }) : null,
      renderMenu ? renderMenu(this.renderTree()) : this.renderTree(),
      renderExtraFooter && renderExtraFooter()
    );
  };

  Tree.prototype.renderNode = function renderNode(node, index, layer, classPrefix) {
    var _this5 = this;

    var _state2 = this.state,
        expandAll = _state2.expandAll,
        selectedValue = _state2.selectedValue;
    var _props3 = this.props,
        _props3$disabledItemV = _props3.disabledItemValues,
        disabledItemValues = _props3$disabledItemV === undefined ? [] : _props3$disabledItemV,
        valueKey = _props3.valueKey,
        labelKey = _props3.labelKey,
        childrenKey = _props3.childrenKey,
        renderTreeNode = _props3.renderTreeNode,
        renderTreeIcon = _props3.renderTreeIcon;


    var refKey = node.refKey;
    var key = (0, _isString3.default)(node[valueKey]) || (0, _isNumber3.default)(node[valueKey]) ? node[valueKey] : refKey;
    var hasChildren = node.hasChildren;

    var children = node[childrenKey];
    var hasNotEmptyChildren = hasChildren !== undefined ? hasChildren : children && Array.isArray(children) && children.length > 0;

    var props = {
      value: node[valueKey],
      label: node[labelKey],
      index: index,
      layer: layer,
      parent: parent,
      active: (0, _utils.shallowEqual)(node[valueKey], selectedValue),
      visible: node.visible,
      children: children,
      nodeData: node,
      disabled: disabledItemValues.filter(function (disabledItem) {
        return (0, _utils.shallowEqual)(disabledItem, node[valueKey]);
      }).length > 0,
      hasChildren: !!children,
      onSelect: this.handleSelect,
      onTreeToggle: this.handleTreeToggle,
      onRenderTreeNode: renderTreeNode,
      onRenderTreeIcon: renderTreeIcon
    };

    if (props.hasChildren) {
      var _classNames;

      layer += 1;
      var expandControlled = 'expandAll' in this.props;
      var expandALlState = expandControlled ? expandAll : expandAll || this.nodes[node.refKey].expand;
      // 是否展开树节点且子节点不为空
      var openClass = classPrefix + '-open';
      var childrenClass = (0, _classnames2.default)(classPrefix + '-node-children', (_classNames = {}, _classNames[openClass] = expandALlState && hasNotEmptyChildren, _classNames));

      var nodes = children || [];
      return React.createElement(
        'div',
        { className: childrenClass, key: key, ref: this.bindNodeRefs.bind(this, refKey) },
        React.createElement(_TreeNode2.default, _extends({
          classPrefix: classPrefix,
          key: key,
          ref: this.bindNodeRefs.bind(this, refKey)
        }, props)),
        React.createElement(
          'div',
          { className: classPrefix + '-children' },
          nodes.map(function (child, i) {
            return _this5.renderNode(child, i, layer, classPrefix);
          })
        )
      );
    }

    return React.createElement(_TreeNode2.default, _extends({
      classPrefix: classPrefix,
      key: key,
      ref: this.bindNodeRefs.bind(this, refKey)
    }, props));
  };

  Tree.prototype.renderTree = function renderTree() {
    var _classNames2,
        _this6 = this;

    var filterData = this.state.filterData;
    var _props4 = this.props,
        height = _props4.height,
        _props4$className = _props4.className,
        className = _props4$className === undefined ? '' : _props4$className,
        inline = _props4.inline;

    // 树节点的层级

    var layer = 0;

    var treeViewClasses = this.addPrefix('tree-view');

    var classes = (0, _classnames2.default)(treeViewClasses, (_classNames2 = {}, _classNames2[className] = inline, _classNames2));
    var nodes = filterData.map(function (dataItem, index) {
      return _this6.renderNode(dataItem, index, layer, treeViewClasses);
    });

    var style = inline ? this.props.style : {};
    var styles = _extends({
      height: height
    }, style);
    return React.createElement(
      'div',
      {
        ref: this.bindTreeViewRef,
        className: classes,
        style: styles,
        onKeyDown: this.handleKeyDown
      },
      React.createElement(
        'div',
        { className: this.addPrefix('tree-view-nodes') },
        nodes
      )
    );
  };

  Tree.prototype.render = function render() {
    var _props5 = this.props,
        inline = _props5.inline,
        locale = _props5.locale,
        open = _props5.open,
        defaultOpen = _props5.defaultOpen,
        disabled = _props5.disabled,
        className = _props5.className,
        toggleComponentClass = _props5.toggleComponentClass,
        placement = _props5.placement,
        classPrefix = _props5.classPrefix,
        placeholder = _props5.placeholder,
        cleanable = _props5.cleanable,
        renderValue = _props5.renderValue,
        valueKey = _props5.valueKey,
        labelKey = _props5.labelKey,
        appearance = _props5.appearance,
        onOpen = _props5.onOpen,
        onClose = _props5.onClose,
        onHide = _props5.onHide,
        container = _props5.container,
        containerPadding = _props5.containerPadding,
        onEnter = _props5.onEnter,
        onEntering = _props5.onEntering,
        onEntered = _props5.onEntered,
        onExit = _props5.onExit,
        onExiting = _props5.onExiting,
        onExited = _props5.onExited,
        block = _props5.block,
        style = _props5.style,
        rest = _objectWithoutProperties(_props5, ['inline', 'locale', 'open', 'defaultOpen', 'disabled', 'className', 'toggleComponentClass', 'placement', 'classPrefix', 'placeholder', 'cleanable', 'renderValue', 'valueKey', 'labelKey', 'appearance', 'onOpen', 'onClose', 'onHide', 'container', 'containerPadding', 'onEnter', 'onEntering', 'onEntered', 'onExit', 'onExiting', 'onExited', 'block', 'style']);

    var activeNode = this.state.activeNode;

    var classes = (0, _getToggleWrapperClassName2.default)('tree', this.addPrefix, this.props, !!activeNode);

    var placeholderText = null;
    var hasValue = activeNode !== null;
    if (hasValue) {
      placeholderText = activeNode && activeNode[labelKey];
    } else if (placeholder) {
      placeholderText = placeholder;
    }

    if (renderValue && hasValue) {
      placeholderText = renderValue(activeNode, placeholderText);
    }

    var unhandled = (0, _utils2.getUnhandledProps)(Tree, rest);
    return !inline ? React.createElement(
      _rsuiteIntl.IntlProvider,
      { locale: locale },
      React.createElement(
        'div',
        {
          className: classes,
          style: style,
          onKeyDown: this.handleToggleKeyDown,
          tabIndex: -1,
          role: 'menu',
          ref: this.bindContainerRef
        },
        React.createElement(
          _OverlayTrigger2.default,
          {
            ref: this.bindTriggerRef,
            open: open,
            defaultOpen: defaultOpen,
            disabled: disabled,
            trigger: 'click',
            placement: placement,
            onEnter: onEnter,
            onEntering: onEntering,
            onEntered: (0, _utils2.createChainedFunction)(this.handleOnOpen, onEntered),
            onExit: onExit,
            onExiting: onExiting,
            onExited: (0, _utils2.createChainedFunction)(this.handleOnClose, onExited),
            onHide: onHide,
            container: container,
            containerPadding: containerPadding,
            speaker: this.renderDropdownMenu()
          },
          React.createElement(
            _PickerToggle2.default,
            _extends({}, unhandled, {
              onClean: this.handleClean,
              cleanable: cleanable && !disabled,
              componentClass: toggleComponentClass,
              hasValue: hasValue
            }),
            placeholderText || React.createElement(_rsuiteIntl.FormattedMessage, { id: 'placeholder' })
          )
        )
      )
    ) : this.renderTree();
  };

  return Tree;
}(React.Component);

Tree.defaultProps = {
  locale: {
    placeholder: 'Select',
    searchPlaceholder: 'Search',
    selectedValues: '{0} selected'
  },
  valueKey: 'value',
  labelKey: 'label',
  cleanable: true,
  placement: 'bottomLeft',
  searchable: true,
  appearance: 'default',
  childrenKey: 'children',
  searchKeyword: ''
};
Tree.handledProps = ['appearance', 'block', 'childrenKey', 'className', 'classPrefix', 'cleanable', 'container', 'containerPadding', 'data', 'defaultExpandAll', 'defaultOpen', 'defaultValue', 'disabled', 'disabledItemValues', 'expandAll', 'height', 'inline', 'labelKey', 'locale', 'menuClassName', 'menuStyle', 'onChange', 'onClose', 'onEnter', 'onEntered', 'onEntering', 'onExit', 'onExited', 'onExiting', 'onExpand', 'onHide', 'onOpen', 'onSearch', 'onSelect', 'open', 'placeholder', 'placement', 'renderExtraFooter', 'renderMenu', 'renderTreeIcon', 'renderTreeNode', 'renderValue', 'searchKeyword', 'searchable', 'style', 'toggleComponentClass', 'value', 'valueKey'];
Tree.propTypes = {
  data: _propTypes2.default.arrayOf(_propTypes2.default.any).isRequired,
  open: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  block: _propTypes2.default.bool,
  value: _propTypes2.default.any,
  height: _propTypes2.default.number,
  inline: _propTypes2.default.bool,
  locale: _propTypes2.default.object.isRequired,
  labelKey: _propTypes2.default.string.isRequired,
  valueKey: _propTypes2.default.string.isRequired,
  container: _propTypes2.default.oneOfType([function () {
    return (typeof HTMLElement === 'function' ? _propTypes2.default.instanceOf(HTMLElement) : _propTypes2.default.any).apply(this, arguments);
  }, _propTypes2.default.func]),
  disabled: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  expandAll: _propTypes2.default.bool,
  cleanable: _propTypes2.default.bool,
  placement: _propTypes2.default.oneOf(['bottomLeft', 'bottomRight', 'topLeft', 'topRight', 'leftTop', 'rightTop', 'leftBottom', 'rightBottom', 'auto', 'autoVerticalLeft', 'autoVerticalRight', 'autoHorizontalTop', 'autoHorizontalBottom']),
  menuStyle: _propTypes2.default.object,
  appearance: _propTypes2.default.oneOf(['default', 'subtle']).isRequired,
  searchable: _propTypes2.default.bool,
  classPrefix: _propTypes2.default.string.isRequired,
  childrenKey: _propTypes2.default.string,
  placeholder: _propTypes2.default.node,
  defaultOpen: _propTypes2.default.bool,
  defaultValue: _propTypes2.default.any,
  menuClassName: _propTypes2.default.string,
  searchKeyword: _propTypes2.default.string,
  defaultExpandAll: _propTypes2.default.bool,
  containerPadding: _propTypes2.default.number,
  disabledItemValues: _propTypes2.default.arrayOf(_propTypes2.default.any),
  toggleComponentClass: function toggleComponentClass() {
    return (typeof (React.ElementType == null ? {} : React.ElementType) === 'function' ? _propTypes2.default.instanceOf(React.ElementType == null ? {} : React.ElementType) : _propTypes2.default.any).apply(this, arguments);
  },
  onOpen: _propTypes2.default.func,
  onExit: _propTypes2.default.func,
  onEnter: _propTypes2.default.func,
  onClose: _propTypes2.default.func,
  onHide: _propTypes2.default.func,
  onSearch: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onExpand: _propTypes2.default.func,
  onSelect: _propTypes2.default.func,
  onExited: _propTypes2.default.func,
  onEntered: _propTypes2.default.func,
  onExiting: _propTypes2.default.func,
  onEntering: _propTypes2.default.func,
  renderMenu: _propTypes2.default.func,
  renderValue: _propTypes2.default.func,
  renderTreeNode: _propTypes2.default.func,
  renderTreeIcon: _propTypes2.default.func,
  renderExtraFooter: _propTypes2.default.func
};

var _initialiseProps = function _initialiseProps() {
  var _this7 = this;

  this.getFocusableMenuItems = function () {
    var filterData = _this7.state.filterData;
    var _props6 = _this7.props,
        childrenKey = _props6.childrenKey,
        _props6$disabledItemV = _props6.disabledItemValues,
        disabledItemValues = _props6$disabledItemV === undefined ? [] : _props6$disabledItemV,
        valueKey = _props6.valueKey;


    var items = [];
    var loop = function loop(nodes) {
      nodes.forEach(function (node) {
        var disabled = disabledItemValues.filter(function (disabledItem) {
          return (0, _utils.shallowEqual)(disabledItem, node[valueKey]);
        }).length > 0;
        if (!disabled) {
          items.push(node);
          if (!node.expand) {
            return;
          }
          if (node[childrenKey]) {
            loop(node[childrenKey]);
          }
        }
      });
    };

    loop(filterData);
    return items;
  };

  this.getElementByDataKey = function (dataKey) {
    var ele = (0, _reactDom.findDOMNode)(_this7.nodeRefs[dataKey]);
    if (ele instanceof Element) {
      return ele.querySelector('.rs-picker-tree-view-node-label');
    }
    return null;
  };

  this.nodes = {};
  this.node = null;
  this.isControlled = null;
  this.tempNode = [];
  this.treeView = null;

  this.bindTreeViewRef = function (ref) {
    _this7.treeView = ref;
  };

  this.trigger = null;

  this.bindTriggerRef = function (ref) {
    _this7.trigger = ref;
  };

  this.container = null;

  this.bindContainerRef = function (ref) {
    _this7.container = ref;
  };

  this.nodeRefs = {};

  this.bindNodeRefs = function (refKey, ref) {
    _this7.nodeRefs[refKey] = ref;
  };

  this.menu = null;

  this.bindMenuRef = function (ref) {
    _this7.menu = ref;
  };

  this.selectActiveItem = function (event) {
    var _getActiveItem = _this7.getActiveItem(),
        nodeData = _getActiveItem.nodeData,
        layer = _getActiveItem.layer;

    _this7.handleSelect(nodeData, +layer, event);
  };

  this.focusNextItem = function () {
    var _getItemsAndActiveInd = _this7.getItemsAndActiveIndex(),
        items = _getItemsAndActiveInd.items,
        activeIndex = _getItemsAndActiveInd.activeIndex;

    if (items.length === 0) {
      return;
    }
    var nextIndex = activeIndex === items.length - 1 ? 0 : activeIndex + 1;
    var node = _this7.getElementByDataKey(items[nextIndex].refKey);
    if (node !== null) {
      node.focus();
    }
  };

  this.focusPreviousItem = function () {
    var _getItemsAndActiveInd2 = _this7.getItemsAndActiveIndex(),
        items = _getItemsAndActiveInd2.items,
        activeIndex = _getItemsAndActiveInd2.activeIndex;

    if (items.length === 0) {
      return;
    }

    var prevIndex = activeIndex === 0 ? items.length - 1 : activeIndex - 1;
    prevIndex = prevIndex >= 0 ? prevIndex : 0;
    var node = _this7.getElementByDataKey(items[prevIndex].refKey);
    if (node !== null) {
      node.focus();
    }
  };

  this.closeDropdown = function () {
    if (_this7.trigger) {
      _this7.trigger.hide();
    }
  };

  this.addPrefix = function (name) {
    return (0, _utils2.prefix)(_this7.props.classPrefix)(name);
  };

  this.shouldDisplay = function (label) {
    var searchKeyword = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this7.state.searchWord;

    if (!(0, _trim3.default)(searchKeyword)) {
      return true;
    }
    var keyword = searchKeyword.toLocaleLowerCase();
    if (typeof label === 'string') {
      return label.toLocaleLowerCase().indexOf(keyword) >= 0;
    } else if (React.isValidElement(label)) {
      var nodes = (0, _utils.reactToString)(label);
      return nodes.join('').toLocaleLowerCase().indexOf(keyword) >= 0;
    }
    return false;
  };

  this.handleTreeToggle = function (nodeData, layer) {
    var _props7 = _this7.props,
        _props7$classPrefix = _props7.classPrefix,
        classPrefix = _props7$classPrefix === undefined ? '' : _props7$classPrefix,
        onExpand = _props7.onExpand;

    var openClass = classPrefix + '-tree-view-open';
    (0, _domLib.toggleClass)((0, _reactDom.findDOMNode)(_this7.nodeRefs[nodeData.refKey]), openClass);
    nodeData.expand = (0, _domLib.hasClass)((0, _reactDom.findDOMNode)(_this7.nodeRefs[nodeData.refKey]), openClass);
    _this7.nodes[nodeData.refKey].expand = nodeData.expand;
    onExpand && onExpand(nodeData, layer);
  };

  this.handleSelect = function (nodeData, layer, event) {
    var _props8 = _this7.props,
        valueKey = _props8.valueKey,
        onChange = _props8.onChange,
        onSelect = _props8.onSelect;

    _this7.node = nodeData;
    if (!_this7.isControlled) {
      _this7.setState({
        activeNode: nodeData,
        selectedValue: nodeData[valueKey]
      });
    }

    onChange && onChange(nodeData[valueKey]);
    onSelect && onSelect(nodeData, layer, event);
    _this7.closeDropdown();
  };

  this.handleKeyDown = function (event) {
    (0, _onMenuKeyDown2.default)(event, {
      down: _this7.focusNextItem,
      up: _this7.focusPreviousItem,
      enter: _this7.selectActiveItem
    });
  };

  this.handleToggleKeyDown = function (event) {
    var classPrefix = _this7.props.classPrefix;

    if (!_this7.treeView) {
      return;
    }
    if (event.target instanceof HTMLElement) {
      var _className = event.target.className;
      if (_className.includes(classPrefix + '-toggle') || _className.includes(classPrefix + '-toggle-custom') || _className.includes(classPrefix + '-search-bar-input')) {
        (0, _onMenuKeyDown2.default)(event, {
          down: _this7.focusNextItem
        });
      }
    }
  };

  this.handleSearch = function (value, event) {
    var filterData = _this7.state.filterData;
    var _props9 = _this7.props,
        onSearch = _props9.onSearch,
        data = _props9.data;

    _this7.setState({
      searchWord: value,
      filterData: _this7.getFilterData(filterData, value)
    });

    onSearch && onSearch(value, event);
  };

  this.handleClean = function () {
    var onChange = _this7.props.onChange;

    _this7.setState({
      activeNode: null,
      selectedValue: null
    });

    _this7.node = null;

    onChange && onChange(null);
  };

  this.handleOnOpen = function () {
    var activeNode = _this7.state.activeNode;
    var onOpen = _this7.props.onOpen;

    if (activeNode) {
      var node = _this7.getElementByDataKey(activeNode.refKey);
      if (node !== null) {
        node.focus();
      }
    }

    onOpen && onOpen();
  };

  this.handleOnClose = function () {
    var onClose = _this7.props.onClose;

    onClose && onClose();
  };
};

(0, _reactLifecyclesCompat.polyfill)(Tree);
var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});

exports.default = enhance(Tree);